# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from ska_oso_odt_services.generated.models.base_model_ import Model
from ska_oso_odt_services.generated.models.error_response_traceback import ErrorResponseTraceback
from ska_oso_odt_services.generated import util

from ska_oso_odt_services.generated.models.error_response_traceback import ErrorResponseTraceback  # noqa: E501

class ErrorResponse(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, status=None, title=None, detail=None, traceback=None):  # noqa: E501
        """ErrorResponse - a model defined in OpenAPI

        :param status: The status of this ErrorResponse.  # noqa: E501
        :type status: int
        :param title: The title of this ErrorResponse.  # noqa: E501
        :type title: str
        :param detail: The detail of this ErrorResponse.  # noqa: E501
        :type detail: str
        :param traceback: The traceback of this ErrorResponse.  # noqa: E501
        :type traceback: ErrorResponseTraceback
        """
        self.openapi_types = {
            'status': int,
            'title': str,
            'detail': str,
            'traceback': ErrorResponseTraceback
        }

        self.attribute_map = {
            'status': 'status',
            'title': 'title',
            'detail': 'detail',
            'traceback': 'traceback'
        }

        self._status = status
        self._title = title
        self._detail = detail
        self._traceback = traceback

    @classmethod
    def from_dict(cls, dikt) -> 'ErrorResponse':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ErrorResponse of this ErrorResponse.  # noqa: E501
        :rtype: ErrorResponse
        """
        return util.deserialize_model(dikt, cls)

    @property
    def status(self):
        """Gets the status of this ErrorResponse.


        :return: The status of this ErrorResponse.
        :rtype: int
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this ErrorResponse.


        :param status: The status of this ErrorResponse.
        :type status: int
        """

        self._status = status

    @property
    def title(self):
        """Gets the title of this ErrorResponse.


        :return: The title of this ErrorResponse.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this ErrorResponse.


        :param title: The title of this ErrorResponse.
        :type title: str
        """

        self._title = title

    @property
    def detail(self):
        """Gets the detail of this ErrorResponse.


        :return: The detail of this ErrorResponse.
        :rtype: str
        """
        return self._detail

    @detail.setter
    def detail(self, detail):
        """Sets the detail of this ErrorResponse.


        :param detail: The detail of this ErrorResponse.
        :type detail: str
        """

        self._detail = detail

    @property
    def traceback(self):
        """Gets the traceback of this ErrorResponse.


        :return: The traceback of this ErrorResponse.
        :rtype: ErrorResponseTraceback
        """
        return self._traceback

    @traceback.setter
    def traceback(self, traceback):
        """Sets the traceback of this ErrorResponse.


        :param traceback: The traceback of this ErrorResponse.
        :type traceback: ErrorResponseTraceback
        """

        self._traceback = traceback
